#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS0"
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1


extern "C" int read(); //these make it work!!
extern "C" int bzero();

class SerialPort {
public:
	SerialPort();
	~SerialPort() {};
	char poll();
	int openPort();
	int closePort();
	int checkStatus();
private:
	struct termios oldtio;
	struct termios newtio;
	int fileDescriptor;
	char currChar;
};

SerialPort::SerialPort() {
	printf("Woohoww!\n");
}

char SerialPort::poll() {
	int foo;
	foo =  read(fileDescriptor,&currChar,1);
	if (foo != 1) printf("Error reading character .... Abort!! Abort!!\n");
	return currChar;
}

int SerialPort::openPort() {
	/* Open the serial port */
	fileDescriptor = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK );
	if (fileDescriptor <0) {perror(MODEMDEVICE); exit(-1); }

	tcgetattr(fileDescriptor,&oldtio); /* save current port settings */

	bzero(&newtio, sizeof(newtio));
	newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
	newtio.c_iflag = IGNPAR;
	newtio.c_oflag = 0;

	/* set input mode */
	newtio.c_lflag = 0;
	newtio.c_cc[VTIME]    = 100;  /* inter-character timer times out at 0.1 sec */
	newtio.c_cc[VMIN]     = 1;    /* blocking read until 1 chars received */

	tcflush(fileDescriptor,TCIFLUSH);
	tcsetattr(fileDescriptor,TCSANOW,&newtio);

	printf("Beginning read from serial port\n");
}

int SerialPort::closePort() {
	printf("Closing serial port\n");
  	tcsetattr(fileDescriptor,TCSANOW,&oldtio);
}

int SerialPort::checkStatus() {
}